#pragma once

#include <ReferenceCounter.h>

class Block;
class Noise;
class Game;

class BiomGenerator : public virtual Framework::ReferenceCounter
{
protected:
    double biomXMultiplier;
    double biomYMultiplier;
    double biomOutputMultiplier;
    double airXMultiplier;
    double airYMultiplier;
    double airOutputMultiplier;

public:
    BiomGenerator();
    virtual Block *getBlock( Noise *zNoise, int x, int y, int z, Game *zGame ) = 0;
    double getBiomXMultiplier();
    double getBiomYMultiplier();
    double getBiomOutputMultiplier();
    double getAirLevelXMultiplier();
    double getAirLevelYMultiplier();
    double getAirLevelOutputMultiplier();
};