#include "EntityType.h"
#include "Entity.h"
#include "Game.h"

EntityType::EntityType( int id )
    : ReferenceCounter(),
    id( id )
{
    StaticRegistry<EntityType>::INSTANCE.registerT( this, id );
}

void EntityType::loadSuperEntity( Entity *zEntity, Framework::StreamReader *zReader ) const
{
    zEntity->loadInventory( zReader );
    zReader->lese( (char *)&zEntity->id, 4 );
    zReader->lese( (char *)&zEntity->maxHP, 4 );
    zReader->lese( (char *)&zEntity->currentHP, 4 );
    zReader->lese( (char *)&zEntity->stamina, 4 );
    zReader->lese( (char *)&zEntity->maxStamina, 4 );
    zReader->lese( (char *)&zEntity->hunger, 4 );
    zReader->lese( (char *)&zEntity->maxHunger, 4 );
    zReader->lese( (char *)&zEntity->thirst, 4 );
    zReader->lese( (char *)&zEntity->maxThirst, 4 );
    zReader->lese( (char *)&zEntity->speed.x, 4 );
    zReader->lese( (char *)&zEntity->speed.y, 4 );
    zReader->lese( (char *)&zEntity->speed.z, 4 );
    zReader->lese( (char *)&zEntity->currentDimensionId, 4 );
}

void EntityType::saveSuperEntity( Entity *zEntity, Framework::StreamWriter *zWriter ) const
{
    zEntity->saveInventory( zWriter );
    zWriter->schreibe( (char *)&zEntity->id, 4 );
    zWriter->schreibe( (char *)&zEntity->maxHP, 4 );
    zWriter->schreibe( (char *)&zEntity->currentHP, 4 );
    zWriter->schreibe( (char *)&zEntity->stamina, 4 );
    zWriter->schreibe( (char *)&zEntity->maxStamina, 4 );
    zWriter->schreibe( (char *)&zEntity->hunger, 4 );
    zWriter->schreibe( (char *)&zEntity->maxHunger, 4 );
    zWriter->schreibe( (char *)&zEntity->thirst, 4 );
    zWriter->schreibe( (char *)&zEntity->maxThirst, 4 );
    zWriter->schreibe( (char *)&zEntity->speed.x, 4 );
    zWriter->schreibe( (char *)&zEntity->speed.y, 4 );
    zWriter->schreibe( (char *)&zEntity->speed.z, 4 );
    zWriter->schreibe( (char *)&zEntity->currentDimensionId, 4 );
}

void EntityType::createSuperEntity( Entity *zEntity ) const
{}

Entity *EntityType::loadEntity( Game *zTarget, Framework::StreamReader *zReader ) const
{
    Entity *entity = createEntity( Framework::Vec3<float>( 0, 0, 0 ), 0, zTarget, 0 );
    loadSuperEntity( entity, zReader );
    return entity;
}

void EntityType::saveEntity( Entity *zEntity, Framework::StreamWriter *zWriter ) const
{
    saveSuperEntity( zEntity, zWriter );
}

Entity *EntityType::createEntityAt( Framework::Vec3<float> position, int dimensionId, Game *zTarget ) const
{
    Entity *entity = createEntity( position, dimensionId, zTarget, zTarget->getNextEntityId() );
    createSuperEntity( entity );
    return entity;
}

int EntityType::getId() const
{
    return id;
}