#include "WorldUpdate.h"

WorldUpdate::WorldUpdate( int dimensionId, Framework::Vec3<int> minAffected, Framework::Vec3<int> maxAffected )
    : ReferenceCounter(),
    affectedDimensionId( dimensionId ),
    minAffected( minAffected ),
    maxAffected( maxAffected )
{}

int WorldUpdate::getAffectedDimension() const
{
    return affectedDimensionId;
}

const Framework::Vec3<int> &WorldUpdate::getMinAffectedPoint() const
{
    return minAffected;
}

const Framework::Vec3<int> &WorldUpdate::getMaxAffectedPoint() const
{
    return maxAffected;
}


WorldUpdateType::WorldUpdateType( int id )
    : ReferenceCounter()
{
    StaticRegistry<WorldUpdateType>::INSTANCE.registerT( this, id );
}